/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.check.error;

import java.util.Optional;

import de.hft.stuttgart.citydoctor2.check.CheckError;
import de.hft.stuttgart.citydoctor2.check.ErrorId;
import de.hft.stuttgart.citydoctor2.check.ErrorReport;
import de.hft.stuttgart.citydoctor2.check.ErrorType;
import de.hft.stuttgart.citydoctor2.check.ErrorVisitor;
import de.hft.stuttgart.citydoctor2.check.HealingMethod;
import de.hft.stuttgart.citydoctor2.check.ModificationListener;
import de.hft.stuttgart.citydoctor2.datastructure.CityObject;
import de.hft.stuttgart.citydoctor2.datastructure.GmlElement;
import de.hft.stuttgart.quality.model.AttributeMissing;
import de.hft.stuttgart.quality.model.ValidationError;

public class AttributeMissingError implements CheckError {

	private static final long serialVersionUID = 185026674309965067L;

	public static final ErrorId ID = new ErrorId("SE_ATTRIBUTE_MISSING");

	private CityObject co;
	private boolean generic;
	private String childId;
	private String nameOfAttribute;

	public AttributeMissingError(CityObject co, String childId, String nameOfAttribute, boolean generic) {
		this.co = co;
		this.childId = childId;
		this.nameOfAttribute = nameOfAttribute;
		this.generic = generic;
	}

	@Override
	public ErrorType getType() {
		return ErrorType.ERROR;
	}

	@Override
	public ErrorId getErrorId() {
		return ID;
	}
	
	public String getChildId() {
		return childId;
	}
	
	public boolean isGeneric() {
		return generic;
	}
	
	public String getNameOfAttribute() {
		return nameOfAttribute;
	}

	@Override
	public GmlElement getFeature() {
		return co;
	}

	@Override
	public void accept(ErrorVisitor errorVisitor) {
		errorVisitor.visit(this);
	}

	@Override
	public boolean accept(HealingMethod method, ModificationListener l) {
		return method.visit(this, l);
	}

	@Override
	public void report(ErrorReport report) {
		report.add("childId", childId);
		report.add("name", nameOfAttribute);
		report.add("generic", "" + generic);
	}

	@Override
	public Optional<ValidationError> convertToQualityAdeDatastructure() {
		AttributeMissing err = new AttributeMissing();
		err.setChildId(childId);
		err.setAttributeName(nameOfAttribute);
		err.setGeneric(generic);
		return Optional.of(err);
	}

}
